<template>
    <div class="d-flex flex-column flex-grow-1">
        <div class="mt-3 p-4 bg-white rounded-1">
            <h6>Select Bus Line</h6>
            <div class="d-flex flex-row flex-wrap gap-2">
                <BaseButton
                    v-for="busLine in busLines"
                    :key="busLine"
                    :class="{active: selectedBusLine === busLine}"
                    @click="selectBusLine(busLine)"
                >
                    {{ busLine }}
                </BaseButton>
            </div>
        </div>
        <div class="d-flex flex-grow-1 gap-3 mt-3">
            <EmptyContent v-if="!selectedBusLine" class="w-50">
                <p class="m-auto">Please select the bus line first</p>
            </EmptyContent>
            <div v-else class="d-flex flex-column bg-white w-50">
                <div class="p-4 pb-0">
                    <h6>Bus Line: {{selectedBusLine}}</h6>
                </div>
                <ListSelect
                    label="Bus Lines"
                    :items="Array.from(store.getters.getStopsByLine(selectedBusLine).keys())"
                    v-model="selectedBusStop"
                    sortable
                ></ListSelect>
            </div>
            <EmptyContent v-if="!selectedBusStop" class="w-50">
                <p class="m-auto">Please select the bus stop first</p>
            </EmptyContent>
            <div v-else class="d-flex flex-column bg-white w-50">
                <div class="p-4 pb-0">
                    <h6>Bus Stop: {{selectedBusStop}}</h6>
                </div>
                <ListSelect
                    label="Bus Stops"
                    :items="busStopTimeItems"
                    sortable
                ></ListSelect>
            </div>
        </div>
    </div>
</template>

<script setup lang="ts">
import { useStore } from 'vuex';
import { computed, ref } from 'vue';
import BaseButton from '@/components/BaseButton.vue';
import EmptyContent from '@/components/EmptyContent.vue';
import ListSelect from '@/components/ListSelect.vue';
import { BusStopContract } from '@/service/Contracts/BusStopContract';

const store = useStore();
store.dispatch('loadBusStops');

const busLines = computed(() => store.getters.busLines);
const busStopTimeItems = computed(() => {
    if (!selectedBusStop.value) return [];
    return Array.from(new Set(store.getters
        .getStopsByLineAndStopName(selectedBusLine.value, selectedBusStop.value)
        .map((busStop: BusStopContract) => busStop.time)
    ));
});
const selectBusLine = (busLine: number) => {
    selectedBusStop.value = undefined;
    selectedBusLine.value = busLine;
};
const selectedBusLine = ref<number>();
const selectedBusStop = ref<string>();
</script>

<style scoped>

</style>
